%  studio dell'errore nel calcolo della approssimazione della 
% derivata prima usando le differenza centrali e le differenze in avanti
%  
% usiamo come funzione test exp(x) e calcoliamo la derivata in x=1
% definiamo un vettore con i valori di h

h = logspace(-20,0,10000);

% approssimiamo la derivata con le differenze in avanti

df_a = ( exp(1+h) - exp(1) )./h;

% approssimiamo la derivata con le differenze centrali

df_c = ( exp(1+h) - exp(1-h) ) ./ (2*h);

err_ass_a =  abs(df_a - exp(1) );
err_ass_c = abs( df_c - exp(1) );

% grafico dell'errore

loglog( h, err_ass_a,'.b',h, err_ass_c,'.r');